HDU 2955——Robberies【01揹包变形】

题目传送门
抢劫方案最优问题,需要一个简单地转换,我们求的是不被抓的概率而非被抓的概率,各个银行的储蓄总和为揹包容量,体积为单个银行的储蓄,价值为不被抓概率。

Problem Description

The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.

For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.

His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.

Input

The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj .
Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .

Output

For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints
0 < T <= 100
0.0 <= P <= 1.0
0 < N <= 100
0 < Mj <= 100
0.0 <= Pj <= 1.0
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.

Sample Input

3
0.04 3
1 0.02
2 0.03
3 0.05
0.06 3
2 0.03
2 0.03
3 0.05
0.10 3
1 0.03
2 0.02
3 0.05

Sample Output

2
4
6

题意:

题目给出所能容忍的最大的被抓概率和n个银行每个银行的钱数及被抓概率。求解在不被抓的情况下所能偷的最大钱数。

分析:

首先是揹包容量的问题:因为概率为浮点数不好遍历,所以选择将银行总钱数作为揹包容量

其次是求不被抓情况下的最大钱数,即求最大的逃跑概率,所以是(1-p[i])。独立事件用乘法。

然后从大到小遍历揹包容量,概率超过(1-p)即输出。

状态方程:dp[j] = max(dp[j], dp[j - w[i]] * (1 - v[i])); //dp[i]为抢i金币后的总逃跑概率。

显然dp[0]=1;

#include <iostream>
#include <vector>
#include <utility>
#include <cstring>
#include <algorithm>
#include <map>
#include <queue>
#include <stack>
#include <cstdio>
#include <fstream>
#include <set>
using namespace std;
typedef long long ll;
#define ios ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);

#define MAXN 10005

double dp[MAXN];
double v[MAXN];
int w[MAXN];
int main() {
	ios;
	int T;
	while (cin >> T) {
		while (T--) {
			memset(dp, 0, sizeof(dp));
			double m;
			int n;
			cin >> m >> n;
			int sum = 0;
			for (int i = 1; i <= n; i++) {
				cin >> w[i] >> v[i];
				sum += w[i];
			}
			dp[0] = 1;
			for (int i = 1; i <= n; i++)
				for (int j = sum; j >= w[i]; j--)
					dp[j] = max(dp[j], dp[j - w[i]] * (1 - v[i]));

			for (int i = sum; i >= 0; i--) {
				if (dp[i] > (1 - m)) {
					cout << i << endl;
					break;
				}
			}
		}
	}
	return 0;
}
發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章